% demo to show the call of full blind source separation (FBSS) algorithm
clc
clear
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% In this demo, the sources are outputs of ARMA models driven by i.i.d. signals of Gamma 
% distribution
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate sources
%%%%%%%%%%%%%%%%%%%%%%%%%
alpha = 1:1:6;
N = length(alpha);
T = 1000;

for n = 1 : N
    s(n,:) = gamrnd(alpha(n),1,1,T);
end

for n = 1 : N
    
    b = randn(3,1);
    s(n,:) = filter(b, 1, s(n,:));
    
end
%s(1,:) = sin(0.1*2*pi*(1:T))+sin(0.213*2*pi*(1:T))/1.71;   % for signal with minus inf entropy rate, take care 

for n = 1 : N
    s(n,:) = s(n,:) - mean(s(n,:));
    s(n,:) = s(n,:)/std(s(n,:));  
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate mixtures
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A = randn(N,N); 
x = A*s;
%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%
% call full bss
W_ERBM_AR = ERBM_AR(x,3);
W_ERM_ARG = ERM_ARG(x,3);
W_ERM_MG = ERM_MG(x);

figure;
T = W_ERBM_AR*A;
for n=1:N
    T(n,:)=T(n,:)/(max(abs(T(n,:))));
end
T=kron(T,ones(50,50));
imshow(abs(T))
title('ERBM-AR confuse matrix')

figure;
T = W_ERM_ARG*A;
for n=1:N
    T(n,:)=T(n,:)/(max(abs(T(n,:))));
end
T=kron(T,ones(50,50));
imshow(abs(T))
title('ERM-ARG confuse matrix')

figure;
T = W_ERM_MG*A;
for n=1:N
    T(n,:)=T(n,:)/(max(abs(T(n,:))));
end
T=kron(T,ones(50,50));
imshow(abs(T))
title('ERM-MG confuse matrix')







